<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class EditConfigParamsResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$updateConfigParams = array();
		$configGroupID = 0;

		$invoice_logo = Factory()->ConfigGroup(0)->getChild("billing")->getChild("pdfInvoice")->getConfigParam("invoice_logo");
		foreach($_REQUEST["configParams"] as $configParam) {
			// find the configGroupID for these params
			if (!$configGroupID) {
				$configGroupID = getConfigParamGroupID($configParam["configParamID"]);
			}
			$configParamID = ((int) $configParam["configParamID"]);
			if ($configParamID != $invoice_logo->config_param_id) {
				$configParamValue = (!is_array($configParam["configParamValue"])) ?
				$configParam["configParamValue"] : $configParam["configParamValue"][0];
			} else {
				$file = $_FILES[$invoice_logo->config_param_name];
				if ("" == $file["name"]){
					continue;
				}

				require_once('FileDownloadClass.php');
				$ext = FileDownloadClass::getFileExt($invoice_logo->config_param_name);
				$default_logo_name = "logo.".$ext;
				require_once('object_managers/InvoiceManager.php');
				if (!in_array($ext, InvoiceManager::getPdfImageTypes())) {
					$this->addError(blmsg("TRANS_ACTIONERROR"), blmsg("TRANS_INCORRECT_IMAGE_FILE_TYPE", array("IMAGE_TYPE" => $ext)));
					$this->addErrorTemplates();
					return $this->hasExecutedSuccessfully();
				}
				FileDownloadClass::downloadFile(Config()->invoiceLogoDirectory, $invoice_logo->config_param_name, $default_logo_name);
				$configParamValue = $default_logo_name;
				if ($configParamValue != $invoice_logo->config_param_value && InvoiceManager::DEFAULT_INVOICE_LOGO_FILE != $invoice_logo->config_param_value) {
					unlink(Config()->invoiceLogoDirectory."/".$invoice_logo->config_param_value);
				}
			}

			$updateConfigParams[] =
				 "<configParam>\n"
				."  <configParamID>".$configParamID."</configParamID>\n"
				."  <configParamValue>".$configParamValue."</configParamValue>\n"
				."</configParam>\n";
		}

		if (count($updateConfigParams)==0 || $configGroupID==0) {
			$this->addError(TRANS_ACTIONERROR, "No config params given.");
		} else {

			$xmlParams = array
			(
				"configGroupID" => $configGroupID,
				"configParams"  => implode("\n",$updateConfigParams)
			);
			require_once("lib-mbapi/mbapi.php");
			$query = getMBAPIQuery("SetConfigs", "update", $xmlParams);
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

                // more logic should be here to determine if the save was good or bad
                // assumption now is that the save is ALWAYS good - MF
                $args = "&saved=1";

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"].$args);
				} else {
					redirect("configs.php",getActionID("ShowConfigs"), array("parentConfigGroupID"=>0));
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}