<?php
require_once mb_path("/lib-action/action.php");

class AddOrderFormResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		global $CONF;
		require_once("object_managers/CompanyManager.php");
		$company = CompanyManager::getProviderCompany();
		$country = Factory()->Country($company->countries_id);
		if(1 == $country->default_gross_price_display) {
			try {
				$default_tax_zone = Factory()->TaxZone($country->countries_iso_2, "countries_iso_2")->tax_zone_id;
			} catch(ProductException $ex) {
				$default_tax_zone = "";
			}
		} else {
			$default_tax_zone = "";
		}
		
		$request_tax_vat_id = $order_form_verify_vat = 0;
		require_once("object_managers/OrderFormManager.php");
		if ( OrderFormManager::isVatCountry($country->countries_iso_2) ) {
			$request_tax_vat_id = $order_form_verify_vat = 1;
		}
		require_once("object_managers/AdminManager.php");
		$admin = AdminManager::getAdmin();
		$conn = DatabaseManager::getConnection();
		$orderFormsCount = $conn->getOne("SELECT MAX(order_form_id) + 1 FROM order_forms");
		$default_name = blmsg("TRANS_ORDERFORM") . " #" . $orderFormsCount;
		$default_code = "store-" . $orderFormsCount;
		$default_widget_template = OrderFormManager::getDefaultWidgetTemplate();
		$default_theme = OrderFormManager::getDefaultTheme();

		$newOrderFormXML = "
<mbapi>
	<command>SetOrderForms</command>
	<subCommand>insert</subCommand>
	<params>
		<orderFormName>{$default_name}</orderFormName>
		<orderFormCode>{$default_code}</orderFormCode>
		<currencyID>USD</currencyID>
		<companyID>{$company->id}</companyID>
		<languageID>{$admin->language_id}</languageID>
		<countriesID>{$admin->countries_id}</countriesID>
		<defaultWidgetTemplate>{$default_widget_template}</defaultWidgetTemplate>
		<defaultTaxZoneID>{$default_tax_zone}</defaultTaxZoneID>
		<requestTaxVatID>{$request_tax_vat_id}</requestTaxVatID>
		<orderFormVerifyVat>{$order_form_verify_vat}</orderFormVerifyVat>
		<isDefault>0</isDefault>
		<orderFormParams>
			<orderFormParam>
				<orderFormParamName>dom_options</orderFormParamName>
				<orderFormParamValue>a:3:{i:0;s:7:\"dom_reg\";i:1;s:12:\"dom_transfer\";i:2;s:12:\"dom_existing\";}</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_DOMAIN_OPTIONS</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_DOMAIN_OPTIONS_DESC</orderFormParamDescription>
				<orderFormParamInputType>c</orderFormParamInputType>
				<orderFormParamOrder>2</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>dom_reg</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_DOMAIN_REGISTRATION</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_transfer</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_TRANSFER_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>2</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_existing</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_EXISTING_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>3</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_skip</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_SKIP_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>4</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>email_banning</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_EMAIL_BANNING</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_EMAIL_BANNING_DESC</orderFormParamDescription>
				<orderFormParamInputType>b</orderFormParamInputType>
				<orderFormParamOrder>3</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>email_banning_text</orderFormParamName>
				<orderFormParamValue>TRANS_ORDER_EMAIL_BANNING_MESSAGE</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_EMAIL_BANNING_TEXT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_EMAIL_BANNING_TEXT_DESC</orderFormParamDescription>
				<orderFormParamInputType>a</orderFormParamInputType>
				<orderFormParamOrder>4</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>ip_banning_text</orderFormParamName>
				<orderFormParamValue>TRANS_ORDER_IP_BANNING_MESSAGE</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_IP_BANNING_TEXT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_IP_BANNING_TEXT_DESC</orderFormParamDescription>
				<orderFormParamInputType>a</orderFormParamInputType>
				<orderFormParamOrder>4</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_check</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_CHECK</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_CHECK_DESC</orderFormParamDescription>
				<orderFormParamInputType>b</orderFormParamInputType>
				<orderFormParamOrder>5</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_invoice</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_INVOICE</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_INVOICE_DESC</orderFormParamDescription>
				<orderFormParamInputType>b</orderFormParamInputType>
				<orderFormParamOrder>6</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_draft</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_BANK_DRAFT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_BANK_DRAFT_DESC</orderFormParamDescription>
				<orderFormParamInputType>b</orderFormParamInputType>
				<orderFormParamOrder>7</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>username_min_length</orderFormParamName>
				<orderFormParamValue>6</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MIN_USERNAME</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MIN_USERNAME_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>8</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>username_max_length</orderFormParamName>
				<orderFormParamValue>15</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MAX_USERNAME</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MAX_USERNAME_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>9</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>password_min_length</orderFormParamName>
				<orderFormParamValue>6</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MIN_PASSWORD</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MIN_PASSWORD_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>10</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>password_max_length</orderFormParamName>
				<orderFormParamValue>15</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MAX_PASSWORD</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MAX_PASSWORD_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>11</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>terms_url</orderFormParamName>
				<orderFormParamValue></orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_TERMS_URL</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_TERMS_URL_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>12</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>theme</orderFormParamName>
				<orderFormParamValue>{$default_theme}</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ONLINE_STORE_COMMON_COLOR_THEME</orderFormParamTransKey>
				<orderFormParamDescription></orderFormParamDescription>
				<orderFormParamInputType>w</orderFormParamInputType>
				<orderFormParamOrder>13</orderFormParamOrder>
			</orderFormParam>
		</orderFormParams>
	</params>
</mbapi>";

		require_once mb_path("/lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($newOrderFormXML, 1);
		$orderFormID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("orderforms.php", getActionID("EditOrderFormSettings"), array("orderFormID" => $orderFormID));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}