<?php
require_once("lib-action/action.php");

class EditIPLog extends MB_Action
{
	function execute()
	{
		parent::execute();

		if(!isset($_REQUEST["ipLogID"])) {
			$this->addError(TRANS_ACTIONERROR, "No IP log id is given.");
		}

		//Get the Panel names for the select list
		$query = new MBQuery("GetServerGroups", "", array("getPanels" => 1));
		$result = $query->getResult();
		if(!$result->getErrorCount()) {
			$serverGroups = grabSimpleMBAPIResults( $result->getStructure() );
			foreach($serverGroups as $key => $value) {
				if(is_array($value["panels"][0]["panel"])) {
					foreach($value["panels"][0]["panel"] as $panelItems) {
						if(notNull($panelItems["configParamValue"])) {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configParamValue"];
						} else {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configGroupID"];
						}
						unset($panelName);
					}
				} else {
					$panels[0] = TRANS_NO_SERVER_FOUND;
				}
			}
			
			$this->mergeSystemNavData();
		}

		$ipLog = Factory()->IPLog($_REQUEST["ipLogID"]);
		
		$this->smartyVars["panels"] = $panels;
		$this->smartyVars["ipLog"]["ipLogID"] = bgpc("ipLogID");
		$this->smartyVars["ipLog"]["ip"] = $ipLog->ip;
		$this->smartyVars["ipLog"]["configGroupID"] = $ipLog->config_group_id;
			
		$this->addTemplate("servers/EditIPLog");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>