<?php

class BuyDomainAction extends CatalogAction {
	
	public function execute($request) {
		
		$planId = $request->getParameter('plan');
		$plan = $this->_store->getPlan($planId);
		
		$cart = ResourceLocator::getInstance()->cart;
		$cartItem = new CartItem($planId);
		
		$cart->setCurrentItem($cartItem);
		
		PurchaseManager::purchaseDomains($request, $this->_store, $cart, $plan, $duplicatedDomains);
		
		$initialPage = new RouterPage('catalog', array('container' => $this->_container));
		
		$steps = array(
			new RouterPage('select-addons'),
			new RouterPage('add-purchase'),
			new RouterPage('summary'),
			new RouterPage('contact-information'),
			new RouterPage('order-details'),
			new RouterPage('confirmation'),
			new RouterPage('thank-you')
		);
		
		$router = new Router();
		$router->init($steps, $initialPage);
		
		ResourceLocator::getInstance()->routersStack->push($router);
		$router->next();
		
		return sfView::NONE;
		
	}
}