<?php

class BillingAccountService extends BillingService {
	
	protected static $instance = null;
	
	public function getCreateAccountForm($storeId) {
		
		if ($customer = sfContext::getInstance()->getUser()->getAttribute('customer')) {
			$contactId = $customer->contactID;
		} else {
			$contactId = null;
		}
		
		$responce = $this->executeGetAccountParams($storeId, $contactId);
		if ($responce->hasErrors()) {
			throw new BillingServiceException('Can not retrieve account form for Store with id "' . $storeId . '"');
		} else {
			return new BillingAccountForm($responce->getData());
		}
	}
	
	public function collectAccountForm($storeId, $values) {
		
	if ($customer = sfContext::getInstance()->getUser()->getAttribute('customer')) {
			$contactId = $customer->contactID;
		} else {
			$contactId = null;
		}
		
		$responce = $this->executeCollectAccountParams($storeId, $contactId, $values);
		return new CollectFormResult($responce->getErrors(), $responce->getViolations(), $responce->getData());
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('account'));
		}
		return self::$instance;
	}
	
}