<?php

class BillingCertificateService extends BillingService {
	
	protected static $instance = null;
	
	public function getCertificateDetailsForm($storeId, $planId) {
		$responce = $this->executeGetCertParams($storeId, $planId);
		if ($responce->hasErrors()) {
			throw new BillingServiceException('Can not retrieve certificate details form for Store with id "' . $storeId . '"');
		} else {
			return new BillingCertificateDetailsForm($responce->getData());
		}
	}
	
	public function collectCertificateDetailsForm($storeId, $planId, $values) {
		$responce = $this->executeGenerateCSR($storeId, $planId, $values);
		return new CollectFormResult($responce->getErrors(), $responce->getViolations(), $responce->getData());
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('certificate'));
		}
		return self::$instance;
	}
	
}