<?php

function formatPrice($amount, $currencyId) {
	$formatter = new NumberFormatter(sfContext::getInstance()->getUser()->getCulture(), NumberFormatter::CURRENCY);
	return $formatter->formatCurrency($amount, $currencyId);
}

function formatRate($rate) {
	$formatter = new NumberFormatter(sfContext::getInstance()->getUser()->getCulture(), NumberFormatter::PERCENT);
	return $formatter->format($rate, NumberFormatter::TYPE_DOUBLE);
}

function formatTax(BillingTaxZone $taxZone, $currencyId = false) {
	if (!(int)$taxZone->taxZoneAmountType) {
		$formatter = new NumberFormatter(sfContext::getInstance()->getUser()->getCulture(), NumberFormatter::PERCENT);
		return $formatter->format((float)$taxZone->taxZoneAmount / 100, NumberFormatter::TYPE_DOUBLE);
	} else {
		$formatter = new NumberFormatter(sfContext::getInstance()->getUser()->getCulture(), NumberFormatter::CURRENCY);
		return $formatter->formatCurrency((float)$taxZone->taxZoneAmount, $currencyId);
	}
}