<?php

function preparePrices($plan, $currencyId) {
	$prices = array();
	
	foreach ($plan->getVariants() as $variant) {
		foreach ($plan->getCycles() as $cycle) {
			if (!$price = $variant->getPrice($cycle->cycleID, $currencyId)) {
				continue;
			}
			
			if ($plan->mustHaveAddons() && !$plan->hasAddAddonAvailability($cycle->cycleID)) {
				continue;
			}
			
			$prices[] = array(
				'id' => $price->getId(),
				'price' => $price,
				'variantName' => $variant->productVariantDisplayName,
				'cycleName' => $cycle->cycleDisplayName
			);
		}
	}
	
	return $prices;
}